Bug 1729983 - huge amount of failures in compat-sap-c++-9 libstdc++ testsuite
Summary: huge amount of failures in compat-sap-c++-9 libstdc++ testsuite
Keywords:
Status: MODIFIED
Alias: None
Product: Red Hat Enterprise Linux 8
Classification: Red Hat
Component: compat-sap-c++-9
Version: ---
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: 8.0
Assignee: Marek Polacek
QA Contact: Alexandra Petlanová Hájková
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2019-07-15 13:38 UTC by Alexandra Petlanová Hájková
Modified: 2020-01-22 17:33 UTC (History)
2 users (show)

Fixed In Version: compat-sap-c++-9-9.1.1-2.3.el8
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: Bug
Target Upstream Version:


Attachments (Terms of Use)

Description Alexandra Petlanová Hájková 2019-07-15 13:38:37 UTC
Description of problem:
There's huge amount of failures in in compat-sap-c++-9 libstdc++ testsuite 

tail libstdc++.sum
# of unexpected failures 5544
# of expected failures 77
# of unsupported tests 1871

=== libstdc++ Summary ===

# of expected passes 8294
# of unexpected failures 11088
# of expected failures 154
# of unsupported tests 3742

Compared with gcc's libstdc++ testsuite:
gcc-toolset-9-gcc:
ppc64le: tail libstdc++.sum
# of unexpected failures 83
# of expected failures 77
# of unsupported tests 545

=== libstdc++ Summary ===

# of expected passes 26304
# of unexpected failures 166
# of expected failures 154
# of unsupported tests 1090

Version-Release number of selected component (if applicable):
compat-sap-c++-9-9.1.1-2.2.el8

How reproducible:
rpmbuild --recompile compat-sap-c++-9-9.1.1-2.2.el8.src.rpm

Comment 1 Marek Polacek 2019-07-15 21:37:02 UTC
I think all the excessive failures are caused by
cc1plus: warning: '-Wformat-security' ignored without '-Wformat' [-Wformat-security]
and this ought to fix it:

--- a/compat-sap-c++-9.spec
+++ b/compat-sap-c++-9.spec
@@ -314,7 +314,8 @@ CONFIGURE_OPTS="\
    "
 
 CC="$CC" CXX="$CXX" CFLAGS="$OPT_FLAGS" \
-   CXXFLAGS="`echo " $OPT_FLAGS " | sed 's/ -Wall / /g;s/ -fexceptions / /g'`" \
+   CXXFLAGS="`echo " $OPT_FLAGS " | sed 's/ -Wall / /g;s/ -fexceptions / /g' \
+         | sed 's/ -Wformat-security / -Wformat -Wformat-security /'`" \
    XCFLAGS="$OPT_FLAGS" TCFLAGS="$OPT_FLAGS" \
    ../configure --enable-bootstrap \
    --enable-languages=c,c++,lto \

Since this is a testsuite problem only (i.e., it shouldn't affect the library itself), I don't think we should do a respin for this.  However, we should still check that the failures are back to normal with this fix applied.  So I propose to do a scratch build, and see what the testsuite results look like.

Alexandra, does this plan sound reasonable to you?

Comment 3 Marek Polacek 2019-07-16 12:30:20 UTC
With that patch x86_64:

        === libstdc++ Summary for unix/ ===
-# of expected passes       4150
-# of unexpected failures   5546
+# of expected passes       13681
+# of unexpected failures   4
 # of expected failures     77
-# of unsupported tests     1869
+# of unsupported tests     328

        === libstdc++ Summary for unix//-fstack-protector ===
-# of expected passes       4150
-# of unexpected failures   5546
+# of expected passes       13681
+# of unexpected failures   4
 # of expected failures     77
-# of unsupported tests     1869
+# of unsupported tests     328
        === libstdc++ Summary ===
-# of expected passes       8300
-# of unexpected failures   11092
+# of expected passes       27362
+# of unexpected failures   8
 # of expected failures     154
-# of unsupported tests     3738
+# of unsupported tests     656
 Compiler version: 9.1.1 20190605 (Red Hat 9.1.1-2) (GCC)

Comment 4 Marek Polacek 2019-07-16 12:32:50 UTC
And ppc64le:

        === libstdc++ Summary for unix/ ===
-# of expected passes       4147
-# of unexpected failures   5544
+# of expected passes       13681
+# of unexpected failures   4
 # of expected failures     77
-# of unsupported tests     1871
+# of unsupported tests     328

So that looks much better now.

Comment 7 Marek Polacek 2020-01-14 19:37:29 UTC
I don't think we have an RHEL 8.2 erratum for this.

Comment 8 Marek Polacek 2020-01-15 18:40:45 UTC
Note that compat-sap-c++-9 in RHEL 8 is based on GCC 9.1.1.  Tillman, do we want to update to GCC 9.2.1 for RHEL 8?


Note You need to log in before you can comment on or make changes to this bug.